Subject: Re: linux-next: build failure after merge of the final tree (pwm tree related)

From: Thierry Reding <[email-masked]>
Date: Tue, 3 Jul 2012 08:11:15 +0200

On Tue, Jul 03, 2012 at 03:43:18PM +1000, Stephen Rothwell wrote:
> Hi all,
> 
> On Sun, 1 Jul 2012 08:56:39 +0200 Thierry Reding <[email-masked]> wrote:
> >
> > But if we make the new PWM symbol conflict with HAVE_PWM, then it'll do
> > the right thing for any of the legacy PWM implementations, without
> > having to track them down. Furthermore it'll also keep the legacy
> > version by default and not allow the generic one to be enabled in that
> > case. This is more likely to cause less side-effects than the other way
> > around.
> > 
> > > One question though: if the generic pwm implementation does not set
> > > HAVE_PWM, how can a driver check its presence?
> > 
> > The driver depends on PWM. HAVE_PWM is the symbol for the legacy
> > implementations, while PWM is the new PWM API symbol.
> 
> I am still getting the mutliple definition errors from my powerpc
> allyesconfg build.
> 
> $ grep PWM .config
> CONFIG_TWL6030_PWM=y
> CONFIG_BACKLIGHT_PWM=y
> CONFIG_PWM=y

I don't see how that can happen. If you have CONFIG_TWL6030_PWM=y, then
you should also have CONFIG_HAVE_PWM=y, which would in turn conflict
with CONFIG_PWM=y.

I'll have to fetch a powerpc toolchain and try to reproduce this.

Thierry